/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*                    BinkleyTerm BBS Session Initiator                     */
/*                                                                          */
/*                                                                          */
/*   This  software  package is being distributed WITH FULL SOURCE CODE     */
/*   with the  following  conditions:    1)  If  anything awful happens     */
/*   because  you  use    it   (or  don't  use  it),  you  accept  full     */
/*   responsibility;  2) you  don't start making tons of voice calls to     */
/*   the authors to complain or  make  suggestions  about enhancements,     */
/*   useful or otherwise;  3) you  do not reuse this code in commercial     */
/*   products without specific permission to do so  from  the  authors;     */
/*   4) If you find any problems you send  fixes  to  the  authors  for     */
/*   inclusion  in  updates;    5) You find some way  to  express  your     */
/*   appreciation  for  this  method of distribution, either by writing     */
/*   code or  application  notes,  or  just sending along a "Thank You"     */
/*   message.                                                               */
/*                                                                          */
/*   There is  copyrighted  code  in  this product.  We either wrote it     */
/*   ourselves or got  permission  to use it.  Please don't force us to     */
/*   pay a lawyer --  have some respect for our motives and don't abuse     */
/*   this "license".                                                        */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <conio.h>

#define WAZOO_SECTION
#define MATRIX_SECTION

#include "com.h"
#include "xfer.h"

extern int      share;          /* Whether to drop FOSSIL */
extern char    *BBSopt;         /* User spec'd BBS call  */
extern struct baud_str btypes[];
extern int      port_ptr;
extern FILE    *status_log;
extern int      baud;

BBSexit ()
{
   int             retval;
   int             xit = 0;
   char            command[80];
   FILE           *bbsbatch;

   /* Wait a half second */
   timer (5);

   /* Now if there is no carrier bag it */
   if (!CARRIER)
      {
      status_line ("!Lost Caller");
      return;
      }

   if (strnicmp (BBSopt, "batch", 5) == 0)      /* if BBS flag is "batch" */
      {
      strcpy (command, "BBSBATCH.BAT"); /* Batch file name        */
      unlink (command);         /* Delete old copies      */
      if ((bbsbatch = fopen (command, "a")) == NULL)    /* Try to open it     */
         {
         status_line ("!Couldn't open BBSBATCH.BAT");
         return;
         }
      errno = 0;
      fprintf (bbsbatch, "SPAWNBBS %d %d %d\n",
               cur_baud, port_ptr + 1, time_to_next ());
      fclose (bbsbatch);
      if (errno)
         {
         status_line ("!Trouble writing BBSBATCH.BAT");
         return;
         }
      xit = 1;
      }

   if ((strnicmp (BBSopt, "exit", 4) == 0) || (xit))    /* "exit" or "batch" ??   */
      {
      retval = cur_baud / 100;
      status_line (":Exiting to BBS with Errorlevel %d", retval);
      if (!share)               /* Turn off FOSSIL,       */
         MDM_DISABLE ();        /* if need be             */
      exit (retval);            /* and exit with error    */
      }

   if (strnicmp (BBSopt, "spawn", 5) == 0)      /* if BBS flag is "spawn" */
      {
      status_line (":Spawning BBS");
      gotoxy (0, 22);
      sprintf (command, "SPAWNBBS %d %d %d",
               cur_baud, port_ptr + 1, time_to_next ());
      close_up ();

      /* Run the BBS */
      system (command);

      come_back ();
      status_line (":Returned from BBS");
      }
}

close_up ()
{
   if (!share)
      MDM_DISABLE ();

   /* Close the log file */
   if (status_log != NULL)
      fclose (status_log);
}

come_back ()
{
   /* Re-enable ourselves */
   if (Cominit (port_ptr) != 0x1954)
      {
      cprintf ("\r\nDarn!  The FOSSIL seems to have gone away!  Exiting\r\n");
      exit (1);
      }

   if (status_log != NULL)
      {
      if ((status_log = fopen (ctl.log_name, "aa")) == NULL)
         {
         cprintf ("\r\nCannot re-open logfile\r\n");
         }
      }

   MDM_ENABLE (btypes[baud].rate);
   opening_banner ();
   mailer_banner ();
}
