.xlist
        page    64,132
        title   FOSSIL Communications routines for BinkleyTerm
        subttl  by Vince Perriello and Bob Hartman
        name    Com_Asm
        .sall
.list
;--------------------------------------------------------------------------;
;                                                                          ;
;                                                                          ;
;      ------------         Bit-Bucket Software <no-Inc>                   ;
;      \ 10001101 /         Writers and Distributors of                    ;
;       \ 011110 /          No-Cost<no-tm> Software.                       ;
;        \ 1011 /                                                          ;
;         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       ;
;                                                                          ;
;                                                                          ;
;                 Assembly routines for BinkleyTerm 1.20                   ;
;                                                                          ;
;                                                                          ;
;   This  software  package is being distributed WITH FULL SOURCE CODE     ;
;   with the  following  conditions:    1)  If  anything awful happens     ;
;   because  you  use    it   (or  don't  use  it),  you  accept  full     ;
;   responsibility;  2) you  don't start making tons of voice calls to     ;
;   the authors to complain or  make  suggestions  about enhancements,     ;
;   useful or otherwise;  3) you  do not reuse this code in commercial     ;
;   products without specific permission to do so  from  the  authors;     ;
;   4) If you find any problems you send  fixes  to  the  authors  for     ;
;   inclusion  in  updates;    5) You find some way  to  express  your     ;
;   appreciation  for  this  method of distribution, either by writing     ;
;   code or  application  notes,  or  just sending along a "Thank You"     ;
;   message.                                                               ;
;                                                                          ;
;   There is  copyrighted  code  in  this product.  We either wrote it     ;
;   ourselves or got  permission  to use it.  Please don't force us to     ;
;   pay a lawyer --  have some respect for our motives and don't abuse     ;
;   this "license".                                                        ;
;                                                                          ;
;                                                                          ;
;--------------------------------------------------------------------------;

        if1
        %out    FOSSIL routines for BinkleyTerm
        %out    KopyRong (K) 1987.  ALL RIGHTS REVERSED.
        endif
        include version.inc
        include msdos.inc
        include cmacros.inc
        if2
        if memS ne 1
        if memM ne 1
        error   <You have to use SMALL data memory for this module.>
        endif
        endif
        endif
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; This module was born at the hands of Wynn Wagner. He wrote the original
; code for use by OPUS-CBCS. We've rewritten and changed it a great deal.
; We added block read and write support (both Rev 4 and 5 versions) with
; backwards compatibility to Rev 3 FOSSIL drivers, and added several
; routines to support this that previously had been just Com_ calls.
;
; We owe Wynn more than we can ever repay. Thank you, Wynn.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       ;;  
;;     DEFINITIONS       ;;
;;                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
MODEM    equ      14H      ; interrupt taken over by FOSSIL programs
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       ;;  
;;       EXTERNAL        ;;
;;     DECLARATIONS      ;;
;;                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
  EXTRN   _fossil_buffer:byte
  EXTRN   _fossil_fetch_pointer:word
  EXTRN   _fossil_count:word
  EXTRN   _out_buffer:byte
  EXTRN   _out_send_pointer:word
  EXTRN   _out_count:word
  EXTRN   _carrier_mask_word:word
  EXTRN   _old_fossil:word
  EXTRN   _time_release:far
  EXTRN   _comm_bits:word
  EXTRN   _parity:word
  EXTRN   _ctrlc_ctr:byte
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       ;;  
;;     DATA SEGMENT      ;;
;;                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
sBegin   data

staticW  Port,0

sEnd
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       ;;  
;;     CODE SEGMENT      ;;
;;                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
sBegin   code

         assumes  cs,code
         assumes  ds,data
                                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _Com_                           ;;
         ;;                                          ;;
         ;; PURPOSE: General calls to FOSSIL         ;;
         ;;                                          ;;
         ;; USAGE:   int Com_(request,parm1);        ;;
         ;;          byte request, parm1;            ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    Com_,<PUBLIC>,<si,di>

         parmB    request
         parmB    parm1

cBegin

         mov      ah, request
         mov      al, parm1
         mov      dx, Port
         int      MODEM

         cld
                
cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _ComInit                        ;;
         ;;                                          ;;
         ;; PURPOSE: Initialize the FOSSIL system    ;;
         ;;                                          ;;
         ;; USAGE:   int ComInit(WhichPort);         ;;
         ;;          byte WhichPort                  ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    ComInit,<PUBLIC>,<si,di>

         parmB    WhichPort

cBegin

	mov	_fossil_fetch_pointer,offset _fossil_buffer
	mov	_fossil_count,0		; Reset all buffer info

	mov	ah,4			; initialization service request
	xor	dh,dh
	mov	dl,WhichPort
	mov	Port,dx
        mov     bx,4f50h                ; setup for the ^C flag
        push    es
        push    ds
        pop     es
        mov     cx,offset _ctrlc_ctr
	int	MODEM
        pop     es

	push	ax

	mov	ax,0f01H		; Use XON/XOFF
	mov	dx,Port
	int	MODEM

	cld
	pop	ax

cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _modem_in                       ;;
         ;;                                          ;;
         ;; PURPOSE: Get a character from com port   ;;
         ;;                                          ;;
         ;; USAGE:   int modem_in();                 ;;
         ;;                                          ;;
         ;; Waits if necessary, returns char in AX.  ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	public	_modem_in
_modem_in	proc far
	cmp	_fossil_count,0		; Anything there?
	je	try_again		; No, go get something.
get_one:
	dec	_fossil_count		; Lower count by one
	mov	bx,_fossil_fetch_pointer; Copy current pointer
	inc	_fossil_fetch_pointer	; Update it for next time
	mov	al,byte ptr [bx]	; Get the current character
	sub	ah,ah			; Clean up the high byte
	ret				; And back to the caller
try_again:
	call	near ptr _fill_buffer	; Fill up the local buffer
	cmp	_fossil_count,0		; See if we got anything
	jne	get_one			; Yes, go give it away
	call	far ptr _time_release	; No, give away a timeslice
	jmp	short try_again		; Then try again
_modem_in	endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _peekbyte                       ;;
         ;;                                          ;;
         ;; PURPOSE: Non-Destructive Read, no wait   ;;
         ;;                                          ;;
         ;; USAGE:   int _peekbyte();                ;;
         ;;                                          ;;
         ;; Returns with char or 0xFFFF in AX.       ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



	public	_peekbyte
_peekbyte	proc far
	cmp	_fossil_count,0		; Anything there?
	je	tommy_can_you		; No, go get something.
see_me:
	mov	bx,_fossil_fetch_pointer; Copy current pointer
	mov	al,byte ptr [bx]	; Get the current character
	sub	ah,ah			; Clean up the high byte
	ret				; And back to the caller
tommy_can_you:
	call	near ptr _fill_buffer	; Fill up the local buffer
	cmp	_fossil_count,0		; See if we got anything
	jne	see_me			; Yes, go give it away
	mov	ax,-1			; No, then say we're empty
	ret				; Let the caller know
_peekbyte	endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _fill_buffer (local routine)    ;;
         ;;                                          ;;
         ;; PURPOSE: get chars from FOSSIL to buffer ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_fill_buffer	proc near

        push    si
	mov	si,offset _fossil_buffer; Point to buffer
	mov	_fossil_fetch_pointer,si; Tell high level what to do
	cmp	_old_fossil,0		; Rev 3 or Rev 4/5?
	jne	old_fill		; Rev 3

        push    di

	mov	cx,127			; Length of buffer to read
        mov     dx,Port			; Put in the port number
	mov	ax,ds
	mov	es,ax			; Get ES set up
        mov     di,si			; Now ES:DI = DS:SI
	mov	ax,1800H		; Block Read function
        int     MODEM			; Call the FOSSIL
	mov	_fossil_count,ax	; Store the count of chars xferred

        pop     di
        pop     si
        cld
	ret	
old_fill:

	mov	ax,0C00H			; Request one character
        mov     dx, Port
        int     MODEM

        cmp     ax,-1                   ; did we get something?
        je      fbuff_done              ; no, so get out

        mov     ax,200H                 ; we got a character, so bring it in
        mov     dx,Port
        int     MODEM

	inc	_fossil_count		; one character
	mov	[si],al			; Store in buffer for consistency

fbuff_done:
        pop     si			; Restore the character
        cld
	ret	

_fill_buffer	endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _clear_inbound                  ;;
         ;;                                          ;;
         ;; PURPOSE: Zero out modem input buffers    ;;
         ;;                                          ;;
         ;; USAGE:   void _clear_inbound();          ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	public	_clear_inbound
_clear_inbound	proc far
	mov	_fossil_fetch_pointer,offset _fossil_buffer
	mov	_fossil_count,0		; Reset all buffer info
	mov	ax,0A00H
	mov	dx, Port
	int	MODEM			; Then tell FOSSIL to do it too
	cld
	ret	

_clear_inbound	endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _clear_outbound                 ;;
         ;;                                          ;;
         ;; PURPOSE: Zero modem output buffers       ;;
         ;;                                          ;;
         ;; USAGE:   void _clear_outbound();         ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	public	_clear_outbound
_clear_outbound	proc far
	mov	_out_send_pointer,offset _out_buffer
	mov	_out_count,0		; Reset all buffer info
	mov	ax,0900H
	mov	dx, Port
	int	MODEM			; Then tell FOSSIL to do it too
	cld
	ret	

_clear_outbound	endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _modem_status                   ;;
         ;;                                          ;;
         ;; PURPOSE: Return FOSSIL and buffer status ;;
         ;;                                          ;;
         ;; USAGE:   int _modem_status();            ;;
         ;;                                          ;;
         ;; Returns with status mask in AX.          ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	public	_modem_status
_modem_status	proc far
	mov	ax,300H
	mov	dx, Port
	int	MODEM			; Get low level FOSSIL status
	cmp	_fossil_count,0		; Do we have characters here?
	je	nothing_here		; No
	or	ax,256			; Yes, OR in the DATA_READY bit
nothing_here:
	cld
	ret				; Status back to the caller

_modem_status	endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _do_break                       ;;
         ;;                                          ;;
         ;; PURPOSE: Start or Stop a BREAK signal    ;;
         ;;                                          ;;
         ;; USAGE:   void _do_break (0/1);           ;;
         ;;                                          ;;
         ;; Starts break if 1, stops if 0.           ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc	do_break,<PUBLIC>
	parmW	on_or_off

cBegin
        mov     ax,on_or_off            ; get on or off status
	mov	ah,1AH                  ; FOSSIL break call
	mov	dx, Port                ; port to use
	int	MODEM			; Do it

cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: mdm_enable                      ;;
         ;;                                          ;;
         ;; PURPOSE: Reset buffers and baud rate     ;;
         ;;                                          ;;
         ;; USAGE:   void mdm_enable(baud_mask);     ;;
         ;;          word baud_mask;                 ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


cProc	mdm_enable,<PUBLIC>
	parmW	BaudRate

cBegin
	mov	_fossil_fetch_pointer,offset _fossil_buffer
	mov	_fossil_count,0		; Reset buffers here
	mov	ax,BaudRate		; Get user's baud rate
        or      ax,_comm_bits                ; add in bit settings
        or      ax,_parity              ; and parity settings
;	or	al,3			; Add in 8 Bits, No Parity
	sub	ah,ah			; Function ZERO sets baudrate
	mov	dx, Port		; Use the current port
	int	MODEM			; Then tell FOSSIL to do it
	cld
cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _mdm_disable                    ;;
         ;;                                          ;;
         ;; PURPOSE: Turn off FOSSIL on current port ;;
         ;;                                          ;;
         ;; USAGE:   void mdm_disable();             ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	public	_mdm_disable
_mdm_disable	proc far
	mov	_fossil_fetch_pointer,offset _fossil_buffer
	mov	_fossil_count,0		; Reset buffers here
	mov	ax,500H			; Function FIVE turns off port
	mov	dx, Port		; Use the current port
	int	MODEM			; Then tell FOSSIL to do it
	cld
	ret	
_mdm_disable	endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _unbuffer_bytes                 ;;
         ;;                                          ;;
         ;; PURPOSE: Flush local and FOSSIL buffers  ;;
         ;;                                          ;;
         ;; USAGE:   void _unbuffer_bytes();         ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        public  _unbuffer_bytes
_unbuffer_bytes proc far

        cmp     _out_count,0
        je      all_done
        mov     ax,1
        push    ax
        push    _out_count
        mov     ax,offset _out_buffer
        push    ax
        call    far ptr _sendchars
        add     sp,6
        mov     _out_count,0                            ; clear chars
        mov     _out_send_pointer,offset _out_buffer    ; reset pointer
all_done:
        ret

_unbuffer_bytes endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _buffer_byte                    ;;
         ;;                                          ;;
         ;; PURPOSE: Store byte, block write if full ;;
         ;;                                          ;;
         ;; USAGE:   void _buffer_byte(asc);         ;;
         ;;          byte asc;                       ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	public	_buffer_byte
_buffer_byte    proc far
        push    bp
        mov     bp,sp

	cmp	_out_count,128          ; Is it full
	je	flush_out 	        ; Yes, so flush it out
looks_good:
	inc	_out_count		; Increment count by one
	mov	bx,_out_send_pointer    ; Copy current pointer
	inc	_out_send_pointer	; Update it for next time
        mov     ax,[bp+6]
	mov	byte ptr [bx],al        ; Get the current character
        mov     sp,bp
        pop     bp
	ret				; And back to the caller
flush_out:
        mov     ax,1
        push    ax
        push    _out_count
        mov     ax,offset _out_buffer
        push    ax
        call    far ptr _sendchars
        add     sp,6
        mov     _out_count,0                            ; clear chars
        mov     _out_send_pointer,offset _out_buffer    ; reset pointer
	jmp	short looks_good	; Then buffer this character
_buffer_byte    endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: sendbyte                        ;;
         ;;                                          ;;
         ;; PURPOSE: Flush buffer, send one byte     ;;
         ;;                                          ;;
         ;; USAGE:   void sendbyte(asc);             ;;
         ;;          byte asc;                       ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


cProc	sendbyte,<PUBLIC>
	parmW	Char

cBegin

try_to_send:
        cmp     _out_count,0             ; anything here to send
        je      send_normal             ; nope, so do just one char
        mov     ax,1
        push    ax
        push    _out_count
        mov     ax,offset _out_buffer
        push    ax
        call    far ptr _sendchars
        add     sp,6
        mov     _out_count,0 
	mov	_out_send_pointer,offset _out_buffer

send_normal:
	mov	ax,Char			; Get character
	mov	ah,0BH			; Write char, no wait
	mov	dx,Port			; To current Port
	int	MODEM			; Tell FOSSIL to do it
	or	ax,ax			; Were we successful?
	jne	sent_it			; Yes, get out
	call	far ptr _time_release	; No, give away a timeslice
	jmp	short try_to_send	; Then try again
sent_it:

cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: sendchars                       ;;
         ;;                                          ;;
         ;; PURPOSE: Explicit Block Write routine    ;;
         ;;                                          ;;
         ;; USAGE:   void sendchars(str,len,car);    ;;
         ;;          char *str;  /* characters */    ;;
         ;;          int len;    /* how many   */    ;;
         ;;          int car;    /* 1=check DCD*/    ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


cProc	sendchars,<PUBLIC>
	parmW	String
        parmW   StrLen
        parmW   CarChek

cBegin
	push	di
	push	si

	mov	si,String		; Pointer to string
	mov	di,StrLen		; StrLen of string (for Rev 3)
wbloop:

	cmp	_old_fossil,0		; Rev 3 FOSSIL?
	jne	wbloop2 		; Yes, go do it that way.

        mov     ax,ds			; Copy DS
        mov     es,ax			; Into ES
	mov	di,si			; Now DS:SI and ES:DI equal.

	mov	bx,StrLen		; StrLen of string
	mov	cx,bx			; Copy count
	mov	ax,1900H		; Write block is 19H.
	mov	dx,Port			; To current Port

	push	si			; Save this in case

	int	MODEM			; Call the FOSSIL

	pop	si			; Restore original pointer
	
	sub	bx,ax			; Subtract number copied
	cmp	bx,0			; Is it zero?
	je	write_block_done	; Yes, exit.

	add	si,ax			; Bump the pointer
	mov	StrLen,bx		; Save current length
wbwait:
	call	far ptr _time_release	; Give up a slice
	cmp	CarChek,0		; Do we want to do carrier check?
	je	wbloop			; No, loop back now
	mov	ax,300H			; Status call is THREE.
	mov	dx,Port
	int	MODEM			; Do status call.
	mov	bx,_carrier_mask_word	; Point to carrier mask
	test	ax,word ptr [bx]	; Check for carrier
	jne	wbloop			; Still there, continue.
	jmp	short write_block_done	; Lost carrier, exit


wbloop2:
	mov	al,byte ptr [si]	; Get character
	mov	ah,0BH			; Write char, no wait
	mov	dx,Port			; To current Port
	int	MODEM			; Tell FOSSIL to do it
	or	ax,ax			; Were we successful?
	je	wbwait          	; No, do time waste processing

	dec	di			; Lower count by 1
	inc	si			; Move pointer by 1
	cmp	di,0			; All done yet?
	jne	wbloop2			; No, keep plugging away.

write_block_done:

	pop	si			; Restore old registers
	pop	di

cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: fossil_block                    ;;
         ;;                                          ;;
         ;; PURPOSE: Generic Block Read/Write code   ;;
         ;;                                          ;;
         ;; USAGE:   int fossil_block(cnum,pntr,len);;;
         ;;          int cnum;    /* Call number */  ;;
         ;;          far *pntr;   /* loc of buff */  ;;
         ;;          int len;     /* how many    */  ;;
         ;;                                          ;;
         ;; Returns with status mask in AX.          ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



cProc    fossil_block,<PUBLIC>
        parmW   cnum
        parmD   pntr
        parmW   len

cBegin

        push    si
        push    di

        MOV     CX,len			; StrLen of buffer to read
        MOV     DX,Port			; Put in the port number
        LES     DI,pntr			; Get ES:DI set up
        LDS     SI,pntr			; Just in case it is rev 4
        MOV     AX,cnum			; Call number
        int     MODEM			; Call the FOSSIL

        pop     di
        pop     si
cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


         page

         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _fossil_gotoxy                  ;;
         ;;                                          ;;
         ;; PURPOSE: Send the local cursor to a      ;;
         ;;          screen location.  Column and    ;;
         ;;          row are both 0-based values.    ;;
         ;;                                          ;;
         ;; USAGE:   void fossil_gotoxy(column,row); ;;
         ;;          unsigned char column, row;      ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    fossil_gotoxy,<PUBLIC>

         parmB    column
         parmB    row

cBegin

         mov      ah, 11h
         mov      dh, row
         mov      dl, column
         int      MODEM

         cld
                
cEnd


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _fossil_whereami                ;;
         ;;                                          ;;
         ;; PURPOSE: Return the current screen       ;;
         ;;          location as two nybbles.        ;;
         ;;                                          ;;
         ;; USAGE:   int fossil_whereami(void);      ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    fossil_whereami,<PUBLIC>

cBegin

         mov      ah, 12h
         int      MODEM
         mov      ax, dx

         cld
                
cEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _fossil_wherey                  ;;
         ;;                                          ;;
         ;; PURPOSE: Return the current column on    ;;
         ;;          the local monitor.              ;;
         ;;                                          ;;
         ;; USAGE:   int wherey(void);               ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    fossil_wherey,<PUBLIC>

cBegin

         mov      ah, 12h
         int      MODEM
         mov      al, dh
         xor      ah, ah

         cld
                
cEnd


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

         page
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;;                                          ;;
         ;; ROUTINE: _fossil_wherex                  ;;
         ;;                                          ;;
         ;; PURPOSE: Return the current row on the   ;;
         ;;          local monitor.                  ;;
         ;;                                          ;;
         ;; USAGE:   int wherex(void);               ;;
         ;;                                          ;;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cProc    fossil_wherex,<PUBLIC>

cBegin

         mov      ah, 12h
         int      MODEM
         mov      al, dl
         xor      ah, ah

         cld
                
cEnd

sEnd
        end

;; END OF FILE: Com_Asm.Asm ;;

